package com.adventurer_engine.util.blockbench;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.adventurer_engine.util.IReadJsonable;
import com.adventurer_engine.util.JsonHelper;
import com.adventurer_engine.util.blockbench.BBModelAnimation;
import com.adventurer_engine.util.blockbench.BBModelElement;
import com.adventurer_engine.util.blockbench.BBModelMetaData;
import com.adventurer_engine.util.blockbench.BBModelOutliner;
import com.adventurer_engine.util.blockbench.BBModelTexture;
import com.google.gson.internal.StringMap;
import java.util.List;
import java.util.Map;
import java.util.TreeMap;

public class BBModel implements IReadJsonable {
  public static Map<String, BBModelElement> elementMap = new TreeMap<String, BBModelElement>();
  
  public static Map<String, BBModelOutliner> outlinerMap = new TreeMap<String, BBModelOutliner>();
  
  public static Map<String, BBModelAnimation> animationMap = new TreeMap<String, BBModelAnimation>();
  
  public BBModelMetaData meta;
  
  public String name;
  
  public String model_identifier;
  
  public double[] visible_box;
  
  public BBModelTexture texture;
  
  public BBModelElement[] elements;
  
  public BBModelOutliner[] outliners;
  
  public StringMap<BBModelAnimation> animations;
  
  public BBModel(JsonHelper json) {
    readJson(json);
  }
  
  public void readJson(JsonHelper json) {
    this.meta = new BBModelMetaData(json.getSubJson("meta"));
    this.name = json.getString("name");
    this.model_identifier = json.getString("model_identifier");
    this.visible_box = json.getDoubleArray("visible_box");
    JsonHelper resolution = json.getSubJson("resolution");
    int width = resolution.getInt("width");
    int height = resolution.getInt("height");
    JsonHelper textures = json.getJsonList("textures").get(0);
    String uuid = textures.getString("uuid");
    String source = textures.getString("source");
    String name = textures.getString("name");
    this.texture = new BBModelTexture(width, height, uuid, source, name);
    List<JsonHelper> ls = json.getJsonList("elements");
    this.elements = new BBModelElement[ls.size()];
    int i;
    for (i = 0; i < ls.size(); i++)
      this.elements[i] = new BBModelElement(ls.get(i)); 
    ls = json.getJsonList("outliner");
    this.outliners = new BBModelOutliner[ls.size()];
    for (i = 0; i < ls.size(); i++)
      this.outliners[i] = new BBModelOutliner(ls.get(i)); 
    if (json.hasKey("animations")) {
      ls = json.getJsonList("animations");
      this.animations = new StringMap();
      for (JsonHelper l : ls) {
        BBModelAnimation animation = new BBModelAnimation(l);
        this.animations.put(animation.name, animation);
      } 
    } 
  }
}
